/*\
|*| ----------------------------------------------------------------------
|*|  KGI chipset driver - kgi-specific initialization and registration
|*| ----------------------------------------------------------------------
|*|
|*|  Copyright 1997 GGI Project, Jason McMullan [jmcc@cs.cmu.edu]
|*|
|*|     This program is free software; you can redistribute it and/or modify
|*|     it under the terms of the GNU General Public License as published by
|*|     the Free Software Foundation; either version 2, or (at your option)
|*|     any later version.
|*|
|*|     You should have received a copy of the GNU General Public License
|*|     along with this program; see the file COPYING.  If not, write to
|*|     the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|*|
|*| ----------------------------------------------------------------------
|*|  $Log: kgi_chipset.inc,v $
|*|  Revision 1.3  1997/12/14 21:55:37  becka
|*|  uint/sint namespace fixed ... please test ...
|*|
|*|  Revision 1.2  1997/06/16 20:43:06  seeger
|*|  Changed to new internal module interface.
|*|  Cosmetic changes to GGI coding style.
|*|
|*|  Revision 1.1  1997/02/27 17:45:07  jochen
|*|  Added Hercules driver.
|*|
|*|  Revision 1.2  1997/02/05 22:55:50  ezrec
|*|  Major:  Fixed the 'cursor follows' point problem, and hardware/software
|*|  	cursor is selectable via the 'CURSOR_HW' define in vga.c
|*|  	NOTE: You _must_ change video modes before anything will display..
|*|
|*|  Revision 1.1  1997/02/03 15:06:34  ezrec
|*|  Major: IBM vga driver (initial version, taken from GGI 0.0.8)
|*|
|*|
|*| ----------------------------------------------------------------------
\*/
 
int kgim_chipset_init(struct kgi_card *card,struct kgi_display *dpy)
{
  int err;

  if ((err=chipset_init(dpy))!=EOK) return err;
 
  strcpy(card->manufact,chipinfo->manufact);
  strcpy(card->model,chipinfo->model);
  card->modes=chipinfo->modes;
  card->flags=chipinfo->flags;
  card->maxdots=chipinfo->maxdots;

  card->chipset=chipinfo;
  card->preset=default_kgi_mode;

  return EOK;
}

void kgim_chipset_done(struct kgi_display *dpy)
{
  chipset_done();
}

int  kgim_chipset_check_mode(struct kgi_display *dpy,
                             struct kgi_mode *mode,enum kgi_tm_cmd cmd)
{
  return chipset_check_mode(dpy,mode,cmd);
}

void kgim_chipset_set_mode(struct kgi_display *dpy, struct kgi_mode *mode)
{
  chipset_set_mode(dpy,mode);
}

int kgim_chipset_ioctl(struct inode *inode,struct file *file,
                       ggi_uint cmd,ulong arg)
{
  return -E(CHIPSET,BOGUS);
}

int kgim_graphics_ioctl(struct inode *inode,struct file *file,
                        ggi_uint cmd,ulong arg)
{
  return -E(GRAPHICS,BOGUS);
}

