/* ---------------------------------------------------------------------------
 * Generic VGA fixed clocks
 * ---------------------------------------------------------------------------
 *
 * Copyright (c) 1995 by Steffen Seeger
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2, or any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * ---------------------------------------------------------------------------
 * 
 * $Log: vga.c,v $
 * Revision 1.6  1997/11/08 15:12:42  becka
 * Namespace cleanup ... probably broke all and everything ...
 *
 * Revision 1.5  1997/10/03 12:37:14  seeger
 * Added standard driver defines.
 *
 * Revision 1.4  1997/09/12 07:28:44  taylorj
 * Minor: Reformatted source to be consistent with GGI coding style guidelines,
 * modified all debugging output to use the DEBUGx macros, and added CVS
 * revision logging to headers where needed.
 *
 * 
 * ---------------------------------------------------------------------------
 * 
 */

#include <ggi/maintainers.h>
#define	MAINTAINER	Steffen_Seeger
#define	DRIVER_NAME	"VGA clock driver"
#define	DRIVER_REV	"$Revision: 1.6 $"


#include <ggi/module.h>

struct kgi_clock clock =
{
	"Generic",		/* Manufacturer		*/
	"VGA",			/* Model		*/
	GM_ALL,			/* Supported modes	*/
	0,			/* Special capabilities	*/
	{ 0x7FFF, 0x7FFF },	/* Maximum resolution	*/
	CLK_TYPE_FIXED,		/* Fixed clock values	*/

	/*	The clock values. Note that they have to be in descending
	**	order and that there must be no repetitions.
	*/
	{{  28322000,  25175000,         0,         0,
	           0,         0,         0,         0,
	           0,         0,         0,         0,
	           0,         0,         0,         0
	}}
};

/* Driving CS[0:3] to clkindex[i] selects clock.clock.freq[i] */
static unsigned char clkindex[MAX_FIXED_CLOCKS] =
{	
	0x01, 0x00, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF
};

static inline struct kgi_clock *init_clock(void)
{
	/* No detection, the chipset driver does it */
	return &clock;
}

static inline void done_clock(void)
{
}

#include "fixed.inc"
