/* ---------------------------------------------------------------------------
 * IBM (VGA) I/O - inline functions
 * --------------------------------------------------------------------------
 *
 * Copyright (C) 1995-1997 by Jason McMullan, [jmcc@cs.cmu.edu]
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * ---------------------------------------------------------------------------
 *
 * $Log: vga_io.inc,v $
 * Revision 1.3  1997/09/13 00:11:30  taylorj
 * *** empty log message ***
 *
 * Revision 1.2  1997/04/17 06:17:15  ezrec
 * Minor: Fixes to work with the new system.h and module.h files...
 *
 * Revision 1.1  1997/04/10 03:34:10  ezrec
 * Major: More fixes, and I'm attempting (ha!) to use Steffen's new MMAP scheme..
 *
 * Revision 1.4  1997/03/05 20:48:43  ezrec
 * Minor: VGA base region no longer conflict with MDA driver...
 *
 * Revision 1.3  1997/02/20 21:59:07  ezrec
 * Minor: jmcc fixes: keypress_wait bug on 2.1.x (console.c)
 * Jochen Hoenicke <Jochen.Hoenicke@Informatik.Uni-Oldenburg.DE> fixed:
 * IBM/vga drivers
 * No-display-on-driver-load bug (woo woo!)
 * set_origin/Attribute handling bugs...
 * Added TEXT_A000_64, for those of you with MDA or
 * Hercules cards (it's now the default, anyway)
 *
 * Revision 1.2  1997/02/04 04:33:45  ezrec
 * Minor: Small bugfixes to cursor and pointer code, but not fixed yet....
 *
 * Revision 1.1  1997/02/03 15:06:35  ezrec
 * Major: IBM vga driver (initial version, taken from GGI 0.0.8)
 *
 * ---------------------------------------------------------------------------
 *	This code was derived from the following source of information:
 *	[1]	XFree86 vga driver
 */

/*\
|*|	Kernel includes
\*/

#include <asm/io.h>

/*\
|*|     GGI includes
\*/

#include <ggi/kgi.h>

#define VGAIO_BASE   0x03C0
#define VGAIO_REGION 0x03E0-VGAIO_BASE

static unsigned short INS1r;
static unsigned short CRTI,CRTD;

static inline void outbMISC(unsigned char value)
{
	outb(value, MISCw);			/* Put value      */
	if (value & MISC_COLOR_IO)		/* Adjust IO base */
	{ 
		
		CRTI = CRTIc; 
		CRTD = CRTDc; 
		INS1r = INS1rc; 
	}
	else
	{
		
		CRTI = CRTIm;
		CRTD = CRTDm;
		INS1r = INS1rm;
	};
}

static inline unsigned char inbCRT(unsigned char reg)
{ 
	outb(reg, CRTI);
	return inb(CRTD); 
}

static inline unsigned char inbSEQ(unsigned char reg)
{ 
	outb(reg, SEQI); 
	return inb(SEQD); 
}

static inline unsigned char inbGRC(unsigned char reg)
{ 
	outb(reg, GRCI); 
	return inb(GRCD); 
}

static inline unsigned char inbATC(unsigned char reg)
{ 
	outb(reg, ATCI); 
	return inb(ATCDr); 
}

static inline void outbCRT(unsigned char value, unsigned char reg) 
{ 
	outw((value << 8) | reg, CRTI); 
}

static inline void outbSEQ(unsigned char value, unsigned char reg)
{ 
	outw((value << 8) | reg, SEQI); 
}

static inline void outbGRC(unsigned char value, unsigned char reg)
{ 
	outw((value << 8 ) | reg, GRCI); 
}

static inline void outbATC(unsigned char value, unsigned char reg)
{ 
	outb(reg, ATCI); 
	outb(value, ATCDw); 
}
