/* Monitor definitions for some multiscan monitors
   See definition of flags in ggi/include/kgi.h
*/

#ifdef __Goldstar_56i__
struct kgi_monitor
monitor = {
       "Goldstar",
       "56i",
       GM_ALL,
       FL_MON_POWERSAVE,
       { 1280, 1024 },

       { 284, 213 },
       VGA_COLOR,
       SYNC_SEPARATE | SYNC_VESA_DPMS | SYNC_MULTISYNC,
       {       0, 110000000 },
       {   30000,     65000 },
       {      50,       120 }
};
#endif

#ifdef __Goldstar_78m__
struct kgi_monitor
monitor = {
       "Goldstar",
       "78m",
       GM_ALL,
       FL_MON_POWERSAVE,
       { 1600, 1280 },

       { 327, 246 },
       VGA_COLOR,
       SYNC_SEPARATE | SYNC_VESA_DPMS | SYNC_MULTISYNC,
       {       0, 135000000 },
       {   30000,     85000 },
       {      50,       120 }
};
#endif

#ifdef __ViewSonic_15G__
struct kgi_monitor
monitor = {
	"ViewSonic",
	"15G",
	GM_ALL,
	FL_MON_POWERSAVE,
	{ 1280, 1024 },

	{ 282, 211 },
	VGA_COLOR,
	SYNC_SEPARATE | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{ 	0, 90000000 },
	{   30000,    64000 },
	{      50,       90 }
};
#endif

#ifdef __4CM6088__
struct kgi_monitor
monitor = {
	"Philips", 
	"4CM6088",
	GM_ALL,
	FL_MON_INTERLACE | FL_MON_POWERSAVE,
	{ 1280,  1024 },

	{ 315, 232 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{         0, 110000000 },
	{     30000,     64000 },
	{        50,       100 }
};
#endif

#ifdef __CPD_1730__
struct kgi_monitor
monitor = {
	"Sony Corporation",
	"CPD-1730",
	GM_ALL,
	FL_MON_INTERLACE | FL_MON_POWERSAVE,
	{ 1024,   768 },

	{ 382, 242 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{         0, 130000000 },
	{     28000,     58000 },
	{        55,       110 }
};
#endif

#ifdef __CPD_15SF1__
struct kgi_monitor
monitor = {
	"Sony Corporation", 
	"CPD-15SF1",
	GM_ALL,
	FL_MON_INTERLACE | FL_MON_POWERSAVE,
	{ 1280,  1024 },

	{ 285, 213 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{         0, 130000000 },
	{     31400,     64000 }, /* Manual says 31.5-64 kHz */
	{        50,       120 }
};
#endif

#ifdef __CPD_17SF1__
struct kgi_monitor
monitor = {
	"Sony Corporation", 
	"CPD-17SF1",
	GM_ALL,
	FL_MON_INTERLACE | FL_MON_POWERSAVE,
	{ 1280,  1024 },

	{ 328, 242 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{         0, 130000000 },
	{     31500,     64000 },
	{        50,       120 }
};
#endif

#ifdef __AlphaScan_15g__
struct kgi_monitor
monitor = {
	"SAMPO", 
	"AlphaScan-15g",
	GM_ALL,
	FL_MON_POWERSAVE,
	{ 1280,   960 },

	{ 285, 213 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{         0, 100000000 },
	{     30000,     60000 },
	{        50,        90 }
};
#endif

#ifdef __AlphaScan_761__
struct kgi_monitor
monitor = {
	"SAMPO", 
	"AlphaScan-761",
	GM_ALL,
	FL_MON_POWERSAVE,
	{ 1600,   1280 },

	{ 300, 225 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{         0, 135000000 },
	{     30000,     86000 },
	{        50,       120 }
};
#endif

#ifdef __Mag_CM2015__
struct kgi_monitor
monitor = {
	"Magnovox", 
	"Mag-CM2015",
	GM_ALL,
	FL_MON_INTERLACE | FL_MON_POWERSAVE,
	{ 1280,  1280 },

	{ 280, 210 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{         0, 135000000 },
	{     30000,     60000 },
	{        50,       100 }
};
#endif

#ifdef __Yak_PS1564__
struct kgi_monitor
monitor = {
	"Yakumo",
	"PS1564",
	GM_ALL,
	FL_MON_INTERLACE | FL_MON_POWERSAVE,
	{ 1280, 1024 },
	{ 270, 210 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_MULTISYNC,
	{ 0, 80000000 },
	{ 30000, 64000 },
	{ 50, 100 }
};
#endif

#ifdef __Hanna_VM1492H__
struct kgi_monitor
monitor = {
	"Hanna", 
	"Hanna-VM1492H",
	GM_ALL,
	FL_MON_INTERLACE,
	{ 1152,   900 },

	{ 270, 200 },
	VGA_COLOR,
	SYNC_ON_RED | SYNC_ON_GREEN | SYNC_ON_BLUE,
	{         0, 135000000 },
	{     29000,     50000 },
	{        47,        90 }
};
#endif

#ifdef __Mag_DX15F__
struct kgi_monitor
monitor = {
	"Mag-Innovision", 
	"Mag-DX15F",
	GM_ALL,
	FL_MON_INTERLACE | FL_MON_POWERSAVE,
	{ 1152,  870 },

	{ 280, 210 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_COMPOSITE | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{         0,  80000000 },
	{     30000,     64000 },
	{        50,       100 }
};
#endif

#ifdef __Mag_MXP17F__
struct kgi_monitor
monitor = {
	"Mag-Innovision", 
	"Mag-MXP17F",
	GM_ALL,
	FL_MON_INTERLACE | FL_MON_POWERSAVE,
	{ 1152,  870 },

	{ 315, 232 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{         0, 130000000 },
	{     30000,     82000 },
	{        50,       120 }
};
#endif

#ifdef __Mag_DX17T__
struct kgi_monitor
monitor = {
	"Mag-Innovision", 
	"Mag-DX17T",
	GM_ALL,
	FL_MON_INTERLACE | FL_MON_POWERSAVE,
	{ 1280,  1024 },
	{ 315, 232 },
	VGA_COLOR,
	SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
	{         0, 100000000 },
	{     28000,     68000 },
	{        50,       100 }
};
#endif

#ifdef __EIZO_F77__
struct kgi_monitor
monitor = {
        "EIZO",
        "FlexScan F77",
        GM_ALL,
        FL_MON_INTERLACE | FL_MON_POWERSAVE,
        { 1600, 1200 },
        { 402, 300 },
        VGA_COLOR,
        SYNC_SEPARATE | SYNC_ON_GREEN | SYNC_COMPOSITE | SYNC_VESA_DPMS
        | SYNC_MULTISYNC,
        {       0, 180000000 },
        {   30000,     95000 },
        {      50,       160 }
};
#endif

#ifdef __ADI_MS4V__
struct kgi_monitor
monitor = {
		"ADI",
		"MicroScan 4v",
		GM_ALL,
		FL_MON_POWERSAVE,
		{ 1280, 1024 },
		{ 280, 210 },
		VGA_COLOR,
		SYNC_SEPARATE | SYNC_VESA_DPMS | SYNC_MULTISYNC,
		{ 0, 85000000 },
		{ 31000, 64000 },
		{ 50, 100 }
	};
#endif
   
#ifdef __ADI_MS5V__
struct kgi_monitor
monitor = {
		"ADI",
		"MicroScan 5v/5v+",
		GM_ALL,
		FL_MON_POWERSAVE,
		{ 1280, 1024 },
		{ 300, 225 },
		VGA_COLOR,
		SYNC_SEPARATE | SYNC_VESA_DPMS | SYNC_MULTISYNC,
		{ 0, 95000000 },
		{ 30000, 64000 },
		{ 50, 100 }
	};
#endif

#ifdef __NEC_M500__
struct kgi_monitor
monitor = {
   "NEC",
   "M500",
   GM_ALL,
   FL_MON_NORMAL,
   { 1280, 1024 },
   { 280, 210 },
   VGA_COLOR,
   SYNC_SEPARATE | SYNC_COMPOSITE | SYNC_ON_GREEN | SYNC_VESA_DPMS
                 | SYNC_MULTISYNC,
   { 0, 85000000 },
   { 30000, 69000 },
   { 55, 120 }
};
#endif

#ifdef __MTS_9564__
struct kgi_monitor
monitor = {
        "ForeFront",
        "MTS-9564",
        GM_ALL,
        FL_MON_POWERSAVE,
        { 1280,   1024 },
        { 280, 210 },
        VGA_COLOR,
        SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
        {         0,  65000000 },
        {     30000,     64000 },
        {        70,       100 }
};
#endif

#ifdef __Nokia_447X__
struct kgi_monitor
monitor = {
        "Nokia",
        "Multigraph-447X",
        GM_ALL,
        FL_MON_POWERSAVE,
        { 1600,   1280 },
        { 300, 225 },
        VGA_COLOR,
        SYNC_NORMAL | SYNC_VESA_DPMS | SYNC_MULTISYNC,
        {     20000, 140000000 }, /* yes the specs had minimum... */
        {     30000,     82000 },
        {        70,       110 }
};
#endif

#ifdef __Liyama_MF_8617T__
struct kgi_monitor
monitor = {
	"Liyama Electric Co, Ltd",
	"Vision Master MF-8617T",
	GM_ALL,
	FL_MON_POWERSAVE,
	{ 1600, 1200 },
	{ 320, 240 },
	VGA_COLOR,
	SYNC_SEPARATE | SYNC_COMPOSITE | SYNC_ON_GREEN | SYNC_VESA_DPMS
		      | SYNC_MULTISYNC,
	{ 0, 160000000 },
	{ 27000, 86000 },
	{ 50, 160 } /* Manuals says 160Hz, but that doesn't look too good */
};
#endif
