/* 
   Graphics library for GGI. Pixels.

   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu
   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "ggi-dl.h"

/*******************************/
/* draw/get/put a single pixel */
/*******************************/

int GGIdrawpixel(ggi_visual *vis,int x,int y)
{
	CHECKXY(vis,x,y);
 
	*(((ushort *)VIS_FB_LINEAR(vis))+y*VIS_FB_WIDTH(vis)+x)=VIS_GC_FGCOLOR(vis);

	return EOK;
}

int GGIputpixel(ggi_visual *vis,int x,int y,ggi_uint col)
{ 
	CHECKXY(vis,x,y);

	*(((ushort *)VIS_FB_LINEAR(vis))+y*VIS_FB_WIDTH(vis)+x)=col;

	return EOK;
}

int GGIgetpixel(ggi_visual *vis,int x,int y,ggi_uint *pixel)
{ 
	if (pixel==NULL)
		return -1;

	CHECKXY(vis,x,y);

	*pixel=*(((ushort *)VIS_FB_LINEAR(vis))+y*VIS_FB_WIDTH(vis)+x);

	return EOK;
	
}

