/* 
   Graphics library for GGI. Pixels.

   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <string.h>

#include "ggi-dl.h"

/*******************************/
/* draw/get/put a single pixel */
/*******************************/

int GGIcopybox(ggi_visual *vis,int x,int y,int w,int h,int nx,int ny)
{
	uchar *obox,*nbox;
	int linew=3*VIS_FB_WIDTH(vis);
	int line;

	CHECKXYWH(vis,x,y,w,h);
	CHECKXYWH(vis,nx,ny,w,h);
	
	if (ny < y) {
		obox=(uchar *)(VIS_FB_LINEAR(vis))+y*linew+3*x;
		nbox=(uchar *)(VIS_FB_LINEAR(vis))+ny*linew+3*nx;
		for (line=0;line<h;line++,obox+=linew,nbox+=linew)
			memmove(nbox,obox,3*w);
	} else {
		obox=(uchar *)(VIS_FB_LINEAR(vis))+(y+h-1)*linew+3*x;
		nbox=(uchar *)(VIS_FB_LINEAR(vis))+(ny+h-1)*linew+3*nx;
		for (line=0;line<h;line++,obox-=linew,nbox-=linew)
			memmove(nbox,obox,3*w);
	}
	return 0;
}
