/* 
   Graphics library for GGI. Horizontal lines.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include <string.h>

#include "ggi-dl.h"

/**********************************/
/* draw/get/put a horizontal line */
/**********************************/

int GGIdrawhline(ggi_visual *vis,int x,int y,int w)
{
	unsigned int colors[3],*bla,i;
	unsigned char *colp =(unsigned char *)colors, *foo;
	
	CHECKXYW(vis,x,y,w);
	
	foo=(unsigned char *)VIS_FB_LINEAR(vis)+(y*VIS_FB_WIDTH(vis)+x)*3;
	while(((x)&3)&&w)
	{  
		*foo++=(VIS_GC_FGCOLOR(vis));
		*foo++=(VIS_GC_FGCOLOR(vis)>>8);
		*foo++=(VIS_GC_FGCOLOR(vis)>>16);
		x++;w--;
	};
	for (i=0;i<4;i++) 
	{
		*colp++=(VIS_GC_FGCOLOR(vis));
		*colp++=(VIS_GC_FGCOLOR(vis)>>8);
		*colp++=(VIS_GC_FGCOLOR(vis)>>16);
	}
	bla=(unsigned int *)foo;
	while (w>3) {
		*bla++=colors[0];
		*bla++=colors[1];
		*bla++=colors[2];
		w-=4;
	};
	foo=(unsigned char *)bla;
	while (w) {
		*foo++=(VIS_GC_FGCOLOR(vis));
		*foo++=(VIS_GC_FGCOLOR(vis)>>8);
		*foo++=(VIS_GC_FGCOLOR(vis)>>16);
		w--;
	};

	return 0;
}

int GGIputhline(ggi_visual *vis,int x,int y,int w,void *buffer)
{ 
	CHECKXYW(vis,x,y,w);

	memcpy((unsigned char *)VIS_FB_LINEAR(vis)+
	       (y*VIS_FB_WIDTH(vis)+x)*3,buffer,w*3);
	
	return 0;
}

int GGIgethline(ggi_visual *vis,int x,int y,int w,void *buffer)
{ 
	CHECKXYW(vis,x,y,w);

	memcpy(buffer,(unsigned char *)VIS_FB_LINEAR(vis)+
	       (y*VIS_FB_WIDTH(vis)+x)*3,w*3);

	return 0;
}
