/* 
   Graphics library for GGI.

   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu
   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "ggi-dl.h"

/********************************/
/* draw/get/put a vertical line */
/********************************/
int GGIdrawvline(ggi_visual *vis,int x,int y,int height)
{
	unsigned char *ptr;
	int w=VIS_FB_WIDTH(vis)*3;
	unsigned char color0=((VIS_GC_FGCOLOR(vis)    ) & 0xff);
	unsigned char color1=((VIS_GC_FGCOLOR(vis)>>8 ) & 0xff);
	unsigned char color2=((VIS_GC_FGCOLOR(vis)>>16) & 0xff);

	CHECKXYH(vis,x,y,height);

	ptr=(unsigned char *)VIS_FB_LINEAR(vis)+y*w+x*3;

	for(;height>0;height--,ptr+=w)
	{
		ptr[0]=color0;
		ptr[1]=color1;
		ptr[2]=color2;
	}
	
	return EOK;
}

int GGIputvline(ggi_visual *vis,int x,int y,int height,void *buffer)
{
	unsigned char *ptr,*pixels=(unsigned char *)buffer;
	int w=VIS_FB_WIDTH(vis)*3;

	CHECKXYH(vis,x,y,height);

	ptr=(unsigned char *)VIS_FB_LINEAR(vis)+y*w+x*3;

	for(;height>0;height--,ptr+=w) 
	{
		
		ptr[0]=pixels[0]; 
		ptr[1]=pixels[1]; 
		ptr[2]=pixels[2];
		pixels+=3;
	}
	
	return EOK;
}

int GGIgetvline(ggi_visual *vis,int x,int y,int height,void *buffer)
{
	unsigned char *ptr,*pixels=(unsigned char *)buffer;
	int w=VIS_FB_WIDTH(vis)*3;

	CHECKXYH(vis,x,y,height);

	ptr=(unsigned char *)VIS_FB_LINEAR(vis)+y*w+x*3;

	for(;height>0;height--,ptr+=w)
	{ 
		pixels[0]=ptr[0];
		pixels[1]=ptr[1];
		pixels[2]=ptr[2];
		pixels+=3;
	}
	
	return EOK;
}

