/* 
   Graphics library for GGI. Horizontal lines.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <string.h>

#include "ggi-dl.h"

/**********************************/
/* draw/get/put a horizontal line */
/**********************************/

int GGIdrawhline(ggi_visual *vis,int x,int y,int w)
{
	CHECKXYW(vis,x,y,w);

	memset((char *)VIS_FB_LINEAR(vis)+y*VIS_FB_WIDTH(vis)+x,
	       VIS_GC_FGCOLOR(vis),w);
	return 0;
}

int GGIputhline(ggi_visual *vis,int x,int y,int w,void *buffer)
{ 
	char *mem;

	CHECKXYW(vis,x,y,w);
	mem=(char *)VIS_FB_LINEAR(vis)+y*VIS_FB_WIDTH(vis)+x;
	memcpy(mem,buffer,w);
	
	return 0;
}

int GGIgethline(ggi_visual *vis,int x,int y,int w,void *buffer)
{ 
	CHECKXYW(vis,x,y,w);

	memcpy(buffer,(char *)VIS_FB_LINEAR(vis)+y*VIS_FB_WIDTH(vis)+x,w);

	return 0;
}

