/* 
 *	(c) 1997 Andreas Beck becka@sunserver1.rz.uni-duesseldorf.de
 * ------------------------------------------------------------------------
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU Library General Public License as 
 *	published by the Free Software Foundation; either version 2, or 
 *	(at your option) any later version.
 * 
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Library General Public License for more details.
 *
 *	You should have received a copy of the GNU Library General Public 
 *	License	along with this program; see the file COPYING.LGPL .  
 *	If not, write to the Free Software Foundation, 675 Mass Ave, 
 *	Cambridge, MA 02139, USA.
 *
 * ------------------------------------------------------------------------
 */ 

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include <sys/ipc.h>
#include <sys/shm.h>
#include <X11/extensions/XShm.h>

#if defined(__osf__) && !defined(XShmQueryExtension)
extern int XShmQueryExtension(Display *);
#endif

struct Xhooks { 
	Display *display;
	XImage *ximage;
	XShmSegmentInfo shminfo;               /* Segment info.  */
	Colormap cmap;
	int cmap_first,cmap_last;
	Window window;
	int xoff,yoff;	/* We can pan, too */
	int ysplit;	/* Emulating Splitline ;-) */
	GC gc;
	int screen;
	int have_shm;
	int XLibLock;	/* SpinLock would probably be more secure, but ... */
};

#define ASYNCSIGNAL SIGPROF
#define ASYNCTIMER  ITIMER_PROF
