#ifndef _ggi_dl_h_
#define _ggi_dl_h_

#include <ggi/ggi.h>
#include "internal.h"

#define CHECKXY(vis,xloc,yloc) \
	{ if ((xloc)<0 || (yloc)<0) return -1; \
	  if ((xloc)>=(VIS_FB_WIDTH(vis))) return -1; \
	  if ((yloc)>=(VIS_FB_HEIGHT(vis))) return -1; }

#define CHECKXYW(vis,xloc,yloc,w) \
	{ CHECKXY(vis,xloc,yloc); \
	  if (((xloc)+(w)) > (VIS_FB_WIDTH(vis))) return -1; \
	  if ((w) <= 0) return -1; }

#define CHECKXYH(vis,xloc,yloc,h) \
	{ CHECKXY(vis,xloc,yloc); \
	  if (((yloc)+(h)) > (VIS_FB_HEIGHT(vis))) return -1; \
	  if ((h) <= 0) return -1; }

#define CHECKXYWH(vis,xloc,yloc,w,h) \
	{ CHECKXY(vis,xloc,yloc); \
          if (((xloc)+(w)) > (VIS_FB_WIDTH(vis))) return -1; \
	  if ((w) <= 0) return -1; \
          if (((yloc)+(h)) > (VIS_FB_HEIGHT(vis))) return -1; \
	  if ((h) <= 0) return -1; }

/* Event handling routines */
ggi_event_mask GGIeventpoll(ggi_visual *vis,ggi_event_mask mask,struct timeval *t);
int GGIeventread(ggi_visual *vis,ggi_event *ev,ggi_event_mask mask);

/* Mode Setting routines */
int GGIsetfocus(ggi_visual *vis);
int GGIgetmode(ggi_visual *vis,ggi_mode *tm);
int GGIsetmode(ggi_visual *vis,ggi_mode *tm);
int GGIcheckmode(ggi_visual *vis,ggi_mode *tm);

/* Accel management 
 */
int GGIflush(ggi_visual *vis);

/* DirectBuffer
 */
int GGIdbinit(ggi_visual *vis);


/* Generic drawing routines
 */
ggi_uint GGImapcolor(ggi_visual *vis,ggi_color color);
int GGIunmappixel(ggi_visual *vis,ggi_uint pixel,ggi_color *color);
int GGIpackcolors(ggi_visual *vis,void *buff,ggi_color *pixels,int len);
int GGIunpackpixels(ggi_visual *vis,void *buff,ggi_color *pixels,int len);

int GGIsetpalvec(ggi_visual *vis,int start,int len,ggi_color *colormap);
int GGIgetpalvec(ggi_visual *vis,int start,int len,ggi_color *colormap);

/* Gamma correction */
int GGIgetgamma(ggi_visual *vis,ggi_float *r,ggi_float *g,ggi_float *b);
int GGIsetgamma(ggi_visual *vis,ggi_float r,ggi_float g,ggi_float b);
int GGIsetgammamap(ggi_visual *vis,int start,int len,ggi_color *gammamap);
int GGIgetgammamap(ggi_visual *vis,int start,int len,ggi_color *gammamap);

int GGIsetorigin(ggi_visual *vis,int x,int y);
int GGIsetsplitline(ggi_visual *vis,int y);

int GGIputc(ggi_visual *vis,int x,int y,char c);
int GGIputs(ggi_visual *vis,int x,int y,const char *string);

int GGIfillscreen(ggi_visual *vis);

int GGIdrawpixel(ggi_visual *vis,int x,int y);
int GGIputpixel(ggi_visual *vis,int x,int y,ggi_uint col);
int GGIgetpixel(ggi_visual *vis,int x,int y,ggi_uint *col);

int GGIdrawline(ggi_visual *vis,int x,int y,int xe,int ye);

int GGIdrawhline(ggi_visual *vis,int x,int y,int w);
int GGIputhline(ggi_visual *vis,int x,int y,int w,void *buf);
int GGIgethline(ggi_visual *vis,int x,int y,int w,void *buf);

int GGIdrawvline(ggi_visual *vis,int x,int y,int h);
int GGIputvline(ggi_visual *vis,int x,int y,int h,void *buf);
int GGIgetvline(ggi_visual *vis,int x,int y,int h,void *buf);

int GGIdrawbox(ggi_visual *vis,int x,int y,int w,int h);
int GGIputbox(ggi_visual *vis,int x,int y,int w,int h,void *buf);
int GGIgetbox(ggi_visual *vis,int x,int y,int w,int h,void *buf);

int GGIcopybox(ggi_visual *vis,int x,int y,int w,int h,int nx,int ny);
int GGIcrossblit(ggi_visual *src,int sx,int sy,int sw,int sh,
		 ggi_visual *dst,int dx,int dy,int dw,int dh);

int GGIdrawcircle(ggi_visual *vis,int x,int y,int r);

#endif /* _ggi_dl_h_ */

