/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "ggi-dl.h"
#include "modex.h"
#include "font/8x8"

/**********TEMPORARY*******/
/* Put a character at x,y */
/**************************/
int GGIputc(ggi_visual *vis,int x,int y,char c)
{
	int bp,yp,off;
	int color;
	unsigned char *field=font+(c<<3),*adr,*adr2;

	CHECKXYWH(vis,x,y,8,8);

	adr=((unsigned char *)__localfb)+(y*(VIS_FB_WIDTH(vis)>>2))+(x>>2);

	for(off=0;off<4;off++) {
	
		adr2=adr+(1<<(((x+off)&3)+16));

		for(yp=0;yp<8;yp++) {

			bp=0x80>>off;
			color=(field[yp] & bp) ? VIS_GC_FGCOLOR(vis) 
				: VIS_GC(vis)->bg_color;
			adr2[0]=color;
			bp>>=4;
			color=(field[yp] & bp) ? VIS_GC_FGCOLOR(vis) 
				: VIS_GC(vis)->bg_color;
			adr2[1]=color;
			adr2+=VIS_FB_WIDTH(vis)>>2;
		}
		if (((x+off)&3)==3) adr++;
	}
	return 0;
}


/****TEMPORARY*******/
/* graphical printf */
/********************/
int GGIputs(ggi_visual *vis,int x,int y,const char *str)
{
	int rc=0;
	
	while(*str) {
		ggiPutc(vis,x,y,*str++);
		rc++;
		if ((x+=8)>=VIS_FB_WIDTH(vis)) {
			x=0;y+=8;
		}
	}

	return rc;
}

