/* 
   Mystique userspace acceleration library

   Copyright (C) 1997 Matthias Grimrath - m.grimrath@tu-bs.de

   Anyone is welcome to improve this lib and send diffs to me.
 
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <string.h>

#include <Matrox/mga_common_lib.h>
#include <Matrox/mga_common_regs.h>

#include "ggi-dl.h"
#include "mystique-8-15-16-32.h"

int GGIdrawhline(ggi_visual *vis,int x,int y,int w)
{
	uint32 *db = (uint32 *)__dmawin;

	DPRINT("drawhline: fg=0x%.8x, x=%d, y=%d, width=%d\n",
	       VIS_GC_FGCOLOR(vis),x,y,w);
	*db++ = ((DMA_FCOL | DMA_GO) << 24) | (DMA_FXBNDRY << 16) |
	        (DMA_YDSTLEN << 8) | (DMA_DWGCTL << 0);
	*db++ = TRAP | __blkmode | SOLID | ARZERO | SGNZERO | SHFTZERO |
	        BOP_COPY | BLTMOD_BMONOLEF;
	*db++ = (y << 16) | 1;
	*db++ = ((x+w) << 16) | x;
	*db++ = VIS_GC_FGCOLOR(vis);

	return ioctl(VIS_FD(vis),GR_MATROX_DMASTOP_AND_WAITACCEL);
}

int GGIdrawvline(ggi_visual *vis,int x,int y,int h)
{
	uint32 *db = (uint32 *)__dmawin;

	DPRINT("drawvline: fg=0x%.8x, x=%d, y=%d, height=%d\n",
	       VIS_GC_FGCOLOR(vis),x,y,h);
	*db++ = ((DMA_FCOL | DMA_GO) << 24) | (DMA_FXBNDRY << 16) |
	        (DMA_YDSTLEN << 8) | (DMA_DWGCTL << 0);
	*db++ = TRAP | __blkmode | SOLID | ARZERO | SGNZERO | SHFTZERO |
	        BOP_COPY | BLTMOD_BMONOLEF;
	*db++ = (y << 16) | h;
	*db++ = ((x+1) << 16) | x;
	*db++ = VIS_GC_FGCOLOR(vis);

	return ioctl(VIS_FD(vis),GR_MATROX_DMASTOP_AND_WAITACCEL);
}

int GGIdrawline(ggi_visual *vis,int x1,int y1,int x2,int y2)
{
	uint32 *db = (uint32 *)__dmawin;

	DPRINT("drawline: fg=0x%.8x, x=1%d, y1=%d, x2=%d, y2=%d\n",
	       VIS_GC_FGCOLOR(vis),x1,y1,x2,y2);
	*db++ = ((DMA_FCOL | DMA_GO) << 24) | (DMA_XYSTRT << 16) |
	        (DMA_XYEND << 8) | (DMA_DWGCTL << 0);
	*db++ = AUTOLINE_CLOSE | ATYPE_RPL | SOLID | SHFTZERO |
	        BOP_COPY | BLTMOD_BFCOL;
	*db++ = (y1 << 16) | x1;
	*db++ = (y2 << 16) | x2;
	*db++ = VIS_GC_FGCOLOR(vis);

	return ioctl(VIS_FD(vis),GR_MATROX_DMASTOP_AND_WAITACCEL);
}
